# coding=utf-8
"""
This code was generated by
\ / _    _  _|   _  _
 | (_)\/(_)(_|\/| |(/_  v1.0.0
      /       /
"""

from twilio.base.domain import Domain
from twilio.rest.insights.v1 import V1


class Insights(Domain):

    def __init__(self, twilio):
        """
        Initialize the Insights Domain

        :returns: Domain for Insights
        :rtype: twilio.rest.insights.Insights
        """
        super(Insights, self).__init__(twilio)

        self.base_url = 'https://insights.twilio.com'

        # Versions
        self._v1 = None

    @property
    def v1(self):
        """
        :returns: Version v1 of insights
        :rtype: twilio.rest.insights.v1.V1
        """
        if self._v1 is None:
            self._v1 = V1(self)
        return self._v1

    @property
    def summary(self):
        """
        :rtype: twilio.rest.insights.v1.summary.CallSummaryList
        """
        return self.v1.summary

    def __repr__(self):
        """
        Provide a friendly representation

        :returns: Machine friendly representation
        :rtype: str
        """
        return '<Twilio.Insights>'
